; 
    include \masm32\include\masm32rt.inc
    include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib    
; 

    ; -------------------------------------------
    ; Build this DLL with the provided MAKEIT.BAT
    ; -------------------------------------------
    ; I want to declare 'hShareWin' as a global variable
    ; which can use as a DLL shared data
    ; Can everybody help me with it ???
    ; Thank you very much
       
      .data  
                
            hShareWind dd 0             
            WH_ACTIVE    dd 1001
         
      .data?
        hInstance    dd ?
      

; #########################################################################

    szText MACRO Name, Text:VARARG
      LOCAL lbl
        jmp lbl
          Name db Text,0
        lbl:
      ENDM

    m2m MACRO M1, M2
      push M2
      pop  M1
    ENDM

    return MACRO arg
      mov eax, arg
      ret
    ENDM
; 

      .code

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 

    .if reason == DLL_PROCESS_ATTACH
    
      mrm hInstance, instance       ; copy local to global
      mov eax, TRUE                 ; return TRUE so DLL will start

    .elseif reason == DLL_PROCESS_DETACH

    .elseif reason == DLL_THREAD_ATTACH

    .elseif reason == DLL_THREAD_DETACH

    .endif

    ret

LibMain endp

; 
; -------------------------------------------------------------------------
;-------------------------- hook procedure --------------------------------
; -------------------------------------------------------------------------

hookProc proc nCode :DWORD, wParam :DWORD, lParam :DWORD

    ; Gui du lieu toi Main Windows
    invoke MessageBox, 0, addr hShareWind, 0, MB_OK
    invoke SendMessage, hShareWind, WH_ACTIVE, wParam, lParam
               
    invoke CallNextHookEx, 0, nCode, wParam, lParam
    return eax

    ret 
    
hookProc endp    

; -------------------------------------------------------------------------
; -------------------- Share handle win -----------------------------------
; -------------------------------------------------------------------------

sharehWind proc hWind :DWORD

    m2m hShareWind, hWind   ; Copy hWind to DLL's global variable

ret

sharehWind endp

; -------------------------------------------------------------------------

end LibMain
